/*
**    Copyright 2009 Sogame
**
**    This file is part of searchOnTab.
**
**    searchOnTab is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    searchOnTab is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with searchOnTab. If not, see <http://www.gnu.org/licenses/>.
*/

var searchOnTab = {
	init: function() {
		var elem = document.getElementById("sot_menuitem");
		if (elem == null) {
			var searchbar = document.getElementById("searchbar");
			var engine_mng = document.getAnonymousElementByAttribute(searchbar, "anonid", "open-engine-manager");
			var parent = engine_mng.parentNode;
			var sot_separator = document.createElement("menuseparator");
			var sot_item = document.createElement("menuitem");
			sot_item.setAttribute("id", "sot_menuitem");
			sot_item.setAttribute("label", document.getElementById("bundle_sot").getString("on_tab"));
			sot_item.setAttribute("type", "checkbox");
			sot_item.setAttribute("checked", searchOnTab.getCurrentStatus());
			sot_item.setAttribute("oncommand", "searchOnTab.toggleSOT();");
			parent.insertBefore(sot_separator, engine_mng);
			parent.insertBefore(sot_item, sot_separator);
			
			searchbar.addEventListener("popupshowing", searchOnTab.updateMenuItemCB, false);
		}
	},
	
	updateMenuItemCB: function() {
		var elem = document.getElementById("sot_menuitem");
		elem.setAttribute("checked", searchOnTab.getCurrentStatus());
	},
	
	toggleSOT: function() {
		// Enable/Disable searchOnTab
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var on_tab = !searchOnTab.getCurrentStatus();
		
		prefs.setBoolPref("browser.search.openintab", on_tab);
	},
	
	getCurrentStatus: function() {
		var on_tab = true;
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		try {
			on_tab = prefs.getBoolPref("browser.search.openintab");
		}
		catch (e) {
			prefs.setBoolPref("browser.search.openintab", on_tab);
		}
		
		return on_tab;
	}
}


window.addEventListener("load", searchOnTab.init, false);
